#include <iostream>
#include <cstdio>      //       C-
#include <cstring>     //     
#include <cctype>      //    
#include <cstdlib>     //    
#include <clocale>     //   setlocale

using namespace std;

//     ( 260 ,      Windows)
const size_t MAX_FILENAME_LENGTH = 260;

//      ( 256 )
const size_t MAX_SEARCH_STRING_LENGTH = 256;

//     
const char* forbidden_chars = "*\"<>?|";

//      
bool isValidFilename(const char* filename) {
    //     
    for (size_t i = 0; i < strlen(forbidden_chars); ++i) {
        if (strchr(filename, forbidden_chars[i]) != nullptr) {
            return false;
        }
    }

    //   
    const char* colon = strchr(filename, ':');
    if (colon != nullptr) {
        //     
        if (colon - filename != 1) {
            return false;
        }
        //     
        if (!isalpha(filename[0])) {
            return false;
        }
        //       
        if (*(colon + 1) != '\\') {
            return false;
        }
    }

    //   
    const char* dot = strrchr(filename, '.');
    if (dot != nullptr) {
        // ,   .txt (  )
        if (strlen(dot) != 4) { //    4 : '.' + 'txt'
            return false;
        }
        //       
        char ext[5];
        strncpy(ext, dot, 4);
        ext[4] = '\0';
        for (int i = 0; i < 4; ++i) {
            ext[i] = tolower(ext[i]);
        }
        if (strcmp(ext, ".txt") != 0) {
            return false;
        }
    }

    return true;
}

//     .txt,   
void addTxtExtension(char* filename) {
    if (strrchr(filename, '.') == nullptr) {
        //  .txt
        strcat(filename, ".txt");
    }
}

int main() {
    //     
    setlocale(LC_ALL, "Russian");  //  Linux/macOS
    //   Windows   setlocale(LC_ALL, "Russian");

    // 4.1.     ,       
    char filename[MAX_FILENAME_LENGTH];
    cout << "  : ";
    cin.getline(filename, MAX_FILENAME_LENGTH);

    // 4.2.    
    if (!isValidFilename(filename)) {
        cout << "  ." << endl;
        return 1; //    
    }

    // 4.3.   .txt,   
    addTxtExtension(filename);

    //     
    if (!isValidFilename(filename)) {
        cout << "     ." << endl;
        return 1;
    }

    // 4.4.     
    //         
    FILE* file = fopen(filename, "rb");
    if (file == nullptr) {
        cout << "   : " << filename << endl;
        return 1;
    }

    //    
    if (fseek(file, 0, SEEK_END) != 0) {
        cout << "     ." << endl;
        fclose(file);
        return 1;
    }

    //   
    long file_size = ftell(file);
    if (file_size == -1L) {
        cout << "    ." << endl;
        fclose(file);
        return 1;
    }

    //    
    rewind(file);

    //       (+1   )
    char* file_content = (char*)malloc(file_size + 1);
    if (file_content == nullptr) {
        cout << "      ." << endl;
        fclose(file);
        return 1;
    }

    //   
    size_t read_size = fread(file_content, sizeof(char), file_size, file);
    if (read_size != (size_t)file_size) {
        cout << "   ." << endl;
        free(file_content);
        fclose(file);
        return 1;
    }

    //        
    file_content[file_size] = '\0';

    //  
    fclose(file);

    // 4.5.      ,      
    char search_string[MAX_SEARCH_STRING_LENGTH];
    cout << "   : ";
    cin.getline(search_string, MAX_SEARCH_STRING_LENGTH);

    // 4.6.          
    int count = 0;
    char* pos = file_content;

    //    
    size_t search_len = strlen(search_string);
    if (search_len == 0) {
        cout << "   ." << endl;
        free(file_content);
        return 1;
    }

    //   
    while ((pos = strstr(pos, search_string)) != nullptr) {
        count++;
        pos += search_len; //  ,    
    }

    cout << "   \"" << search_string << "\": " << count << endl;

    // 4.7.   
    free(file_content);

    return 0;
}
